package cz.fidentis.analyst.mesh.core;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import javax.vecmath.Vector3d;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

/**
 *
 * @author oslejsek
 */
public class MeshTriangleTest {
    
    protected MeshTriangle getTriangle() {
        MeshTriangle triangle = new MeshTriangle(
                new MeshPointImpl(new Vector3d(1, 0, 0), null, null),
                new MeshPointImpl(new Vector3d(1, 2, 0), null, null),
                new MeshPointImpl(new Vector3d(2, 0, 0), null, null),
                0, 1, 2
        );
        return triangle;
    }
    
    @Test
    public void getClosestPointTest() {
        MeshTriangle tri = new MeshTriangle(
                new MeshPointImpl(new Vector3d(1, 0, 0), null, null),
                new MeshPointImpl(new Vector3d(1, 2, 0), null, null),
                new MeshPointImpl(new Vector3d(2, 0, 0), null, null),
                0, 1, 2
        );
        Assertions.assertEquals(new Vector3d(1, 0, 0), tri.getClosestPoint(new Vector3d(0, 0, 0)));
        Assertions.assertEquals(new Vector3d(1, 1, 0), tri.getClosestPoint(new Vector3d(0, 1, 0)));
        Assertions.assertEquals(new Vector3d(1, 2, 0), tri.getClosestPoint(new Vector3d(0, 3, 0)));
        Assertions.assertEquals(new Vector3d(1, 0, 0), tri.getClosestPoint(new Vector3d(1, 0, -1)));
        Assertions.assertEquals(new Vector3d(1.2, 0.2, 0), tri.getClosestPoint(new Vector3d(1.2, 0.2, -1)));
    }

}
